/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.egreso;

import danielcortes.xyz.data.ConnectionHolder;
import danielcortes.xyz.models.caja.Caja;
import danielcortes.xyz.models.caja.CajaDAO;
import danielcortes.xyz.models.caja.SQLiteCajaDAO;
import danielcortes.xyz.models.tipo_egreso.SQLiteTipoEgresoDAO;
import danielcortes.xyz.models.tipo_egreso.TipoEgreso;
import danielcortes.xyz.models.tipo_egreso.TipoEgresoDAO;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.time.YearMonth;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public abstract class EgresoDAO {
    private static final Logger LOGGER = Logger.getLogger(EgresoDAO.class.getName());

    protected ConnectionHolder connectionHolder;

    public abstract List<Egreso> findAll();

    public abstract List<Egreso> findById(int id);

    public abstract List<Egreso> findByCaja(Caja caja);

    public abstract List<Egreso> findByNro(String nro);

    public abstract List<Egreso> findByTipoEgreso(TipoEgreso tipoEgreso);

    public abstract boolean insertEgreso(Egreso egreso);

    public abstract boolean updateEgreso(Egreso egreso);

    public abstract boolean deleteEgreso(Egreso egreso);

    public abstract int getTotalEgreso(Caja caja);

    public abstract int getTotalEgresoMesPorTipo(YearMonth mes, TipoEgreso tipo);

    List<Egreso> egresosFromResultSet(ResultSet rs) throws SQLException {
        ArrayList<Egreso> egresoList = new ArrayList<>();
        while (rs.next()) {
            int tipoEgresoId = rs.getInt("tipo_egreso_id");
            TipoEgresoDAO tipoEgresoDAO = new SQLiteTipoEgresoDAO();
            TipoEgreso tipoEgreso = tipoEgresoDAO.findById(tipoEgresoId).get(0);

            int cajaId = rs.getInt("caja_id");
            CajaDAO cajaDAO = new SQLiteCajaDAO();
            Caja caja = cajaDAO.findById(cajaId);

            Egreso egreso = new Egreso();

            egreso.setId(rs.getInt("id"));
            egreso.setNro(rs.getString("nro"));
            egreso.setDescripcion(rs.getString("descripcion"));
            egreso.setValor(rs.getInt("valor"));
            egreso.setTipoEgreso(tipoEgreso);
            egreso.setCaja(caja);

            LOGGER.log(Level.FINER, "Se a creado: {0}", egreso);

            egresoList.add(egreso);
        }
        return egresoList;
    }
}
